package com.cht.tas.ivr;

import org.eclipse.paho.client.mqttv3.MqttMessage;
import org.json.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

@Component
public class IVREvent {
    private final Logger Log = LoggerFactory.getLogger(IVREvent.class);

    @Value("${mqtt.phone-conn.actionTopic}")
    private String actionTopic = "";

    @Autowired
    private MqttTas mqttPhone;

    public void menu_2(JSONObject reqJObjs){
        JSONObject respJObjs = new JSONObject();
        respJObjs.put("id", reqJObjs.getString("id"));

        //可動態查詢目前的空氣狀況，並指定文字內容
        String text = "台北空氣品質指標良好";

        respJObjs.put("node","menu2");
        respJObjs.put("text", text);
        respJObjs.put("nextNode","MAIN");

        MqttMessage message = new MqttMessage(respJObjs.toString().getBytes());
        mqttPhone.publish(actionTopic, message);
        return;
    }

    public void weather_menu_1(JSONObject reqJObjs){
        JSONObject respJObjs = new JSONObject();
        respJObjs.put("id", reqJObjs.getString("id"));

        respJObjs.put("node","weather_menu_1");
        respJObjs.put("text","台北氣溫 28 度");
        // text 內容播放2次
        respJObjs.put("repeat",2);
        respJObjs.put("nextNode","exit");

        MqttMessage message = new MqttMessage(respJObjs.toString().getBytes());
        mqttPhone.publish(actionTopic, message);
        return;
    }

    public void weather_menu_2(JSONObject reqJObjs){
        JSONObject respJObjs = new JSONObject();
        respJObjs.put("id", reqJObjs.getString("id"));

        respJObjs.put("node","weather_menu_2");
        respJObjs.put("text","台中氣溫 29 度");
        //查詢完挑轉 exit 節點，結束通話
        respJObjs.put("nextNode","exit");

        MqttMessage message = new MqttMessage(respJObjs.toString().getBytes());
        mqttPhone.publish(actionTopic, message);
        return;
    }

    public void weather_menu_3(JSONObject reqJObjs){
        JSONObject respJObjs = new JSONObject();
        respJObjs.put("id", reqJObjs.getString("id"));

        respJObjs.put("node","weather_menu_3");
        respJObjs.put("text","高雄氣溫 30 度");

        //女生發音
        respJObjs.put("promptMode","F");
        //查詢完直接結束通話
        respJObjs.put("nextNode","END");

        MqttMessage message = new MqttMessage(respJObjs.toString().getBytes());
        mqttPhone.publish(actionTopic, message);
        return;
    }

    public void weather_menu_other(JSONObject reqJObjs){
        JSONObject respJObjs = new JSONObject();
        respJObjs.put("id", reqJObjs.getString("id"));

        //直接挑轉至 exit 節點，結束通話
        respJObjs.put("node","goto_exit");
        respJObjs.put("nextNode","exit");

        MqttMessage message = new MqttMessage(respJObjs.toString().getBytes());
        mqttPhone.publish(actionTopic, message);
        return;
    }

}
